unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, jpeg, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    DriveComboBox1: TDriveComboBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    Edit4: TEdit;
    Label4: TLabel;
    Edit5: TEdit;
    Label5: TLabel;
    Button4: TButton;
    Button5: TButton;
    Label6: TLabel;
    Button6: TButton;
    Edit6: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Edit7: TEdit;
    CheckBox1: TCheckBox;
    ProgressBar1: TProgressBar;
    StatusBar1: TStatusBar;
    CheckBox2: TCheckBox;
    Button7: TButton;
    Memo2: TMemo;
    Memo3: TMemo;
    Button8: TButton;
    Button9: TButton;
    Edit8: TEdit;
    OpenDialog1: TOpenDialog;
    Button10: TButton;
    Label9: TLabel;
    SaveDialog1: TSaveDialog;
    TrackBar1: TTrackBar;
    Label10: TLabel;
    Image1: TImage;
    Label11: TLabel;
    Label12: TLabel;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    Image2: TImage;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    Label19: TLabel;
    Button11: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox6Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
datentraegerbezeichnung:string;
aktuelle_speicherzelle,laenge_des_werts, zahler: integer;
datentraegergroesse, belegter_speicher,anzahl_eintraege,anzahl_ordner,beginn_der_toc,ende_der_toc:integer;
ordnername,dateiname:string;
datum_tag,datum_monat,datum_jahr,uhr_stunde,uhr_minute,uhr_sekunde:integer;
dateianfang_sektor,dateiende_segment,dateiende_sektor:integer;
position_hoehe,position_nord,position_ost:real;
Mtoc_gelesen:boolean;
DecimalSeparator: Char;
fs:TFilestream;
image:TFilestream;
image_geladen:boolean;
imagedateiname:string;
rominhalt:string;
buf:array[0..511] of byte;
anfangssektor, endsektor,aktiversektor,segmentende,endelement,zeit_anfang,zeit_anfang_sektor: integer;
datenrate,datenrate_sektor:real;
imagezaehler,bufferzaehler,toc_unterschied_min:integer;
pos_x_r:array[0..10000] of real;
pos_y_r:array[0..10000] of real;
pos_ges_bildnr:array[0..10000] of integer;
pos_x_b:array[0..10000] of integer;
pos_y_b:array[0..10000] of integer;
pos_x_r_max,pos_x_r_min,pos_y_r_max,pos_y_r_min:real;
scale_factor_x,scale_factor_y,unterschied,unterschied_min:real;
pos_zaehler_b:integer;
jpeg2: TJPEGImage;
bmp,bmp_2: TBitmap;
xzahler,yzahler:integer;
implementation

{$R *.DFM}

Procedure Turn180(Bitmap : tBitmap);
Type    tLine           =       Array[0..$FFFF] of Byte; 
Var     LineWidth, y    :       Integer; 
        Line            :       ^tLine;                             
Begin 
LineWidth := Bitmap.Width;
Case Bitmap.PixelFormat of
        pf1Bit  : LineWidth := LineWidth SHR 3; 
        pf4Bit  : LineWidth := LineWidth SHR 1;      
        pf16Bit : LineWidth := LineWidth SHL 1;      
        pf24Bit : LineWidth := LineWidth * 3;      
        pf32Bit : LineWidth := LineWidth SHL 2;      
End; 
GetMem(Line, LineWidth);
For y := 0 to ((Bitmap.Height - 1) div 2) do Begin 
        Move(Bitmap.ScanLine[Bitmap.Height - 1 - y]^, Line[0], LineWidth);
        Move(Bitmap.ScanLine[y]^, Bitmap.ScanLine[Bitmap.Height - 1 - y]^, LineWidth);
        Move(Line[0], Bitmap.ScanLine[y]^, LineWidth); 
End;

FreeMem(Line, LineWidth);
End;


function ReadSector(Sector: Integer; buffer: pointer; Drive: string):Boolean; 
const 
  SectorSize = 512;
var 
  hDevice: THandle; 
  DevName: string; 
  nb: {$IFDEF VER100}Integer{$ELSE}Cardinal{$ENDIF}; 
begin 
 
  result:=false;
  if WIN32PLATFORM = VER_PLATFORM_WIN32_NT then 
  begin 
    DevName := '\\.\'+Drive; 
    hDevice := CreateFile(pChar(DevName), GENERIC_READ, 
      FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 
      FILE_ATTRIBUTE_NORMAL, 0); 
    if (hDevice = INVALID_HANDLE_VALUE) then 
    begin 
      Result:=False; 
      Exit; 
    end; 
    SetFilePointer(hDevice, (Sector-1) * SectorSize, 
      nil, FILE_BEGIN ); 
    Result := ReadFile(hDevice, buffer^, SectorSize, nb, nil) and 
      (nb=SectorSize); 
    CloseHandle(hDevice); 
  end;
  
end;

function ByteToHex(InByte:byte):shortstring;
const Digits:array[0..15] of char='0123456789ABCDEF';
begin
 result:=digits[InByte shr 4]+digits[InByte and $0F];
end;


procedure TForm1.Button1Click(Sender: TObject);
var buf:array[0..511] of byte;
anfangssektor, endsektor,aktiversektor, zahler,segmentende: integer;
hexstring: string;
//-2147483648 bis 2147483647
fs:TFilestream;
begin
  anfangssektor:=strtoint(form1.edit1.text);
  endsektor:=strtoint(form1.edit2.text);
  segmentende:=strtoint(form1.edit5.text);
  aktiversektor:=anfangssektor;
  memo1.Text:='';
  hexstring:='';
  while aktiversektor<=endsektor do begin
  ReadSector(aktiversektor,@buf,form1.DriveComboBox1.Text);
  zahler:=0;
  if aktiversektor<>endsektor then begin
  while zahler<=511 do begin
  hexstring:=hexstring+ByteTohex(buf[zahler])+' ';
  zahler:=zahler+1;
  end;
  end
  else begin
  while zahler<=segmentende do begin
  hexstring:=hexstring+ByteTohex(buf[zahler])+' ';
  zahler:=zahler+1;
  end;
  end;
  aktiversektor:=aktiversektor+1;
  end;
  form1.memo1.Text:=hexstring;
  form1.Memo1.Lines.SaveToFile(form1.edit3.text);
  //fs:=TFilestream.create('B_'+form1.edit3.text,fmCreate or fmOpenReadWrite);
  //fs.Write(buf,sizeOf(buf));
  //fs.free;
end;
procedure TForm1.Button2Click(Sender: TObject);
var
buf:array[0..511] of byte;

begin
if Mtoc_gelesen=false then begin
if image_geladen=false then begin
ReadSector(2,@buf,form1.DriveComboBox1.Text);
end
else begin
imagezaehler:=(2-1)*512+1;
bufferzaehler:=0;
while bufferzaehler<512 do begin
buf[bufferzaehler]:=byte(rominhalt[imagezaehler+bufferzaehler]);
bufferzaehler:=bufferzaehler+1;
end;
end;
datentraegerbezeichnung:='';
laenge_des_werts:=16;
zahler:=0;
aktuelle_speicherzelle:=0;
while zahler<laenge_des_werts do begin
datentraegerbezeichnung:=datentraegerbezeichnung+chr(buf[aktuelle_speicherzelle]);
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
zahler:=zahler+1;
end;
memo1.lines.add('Datentraegerbezeichnung: '+datentraegerbezeichnung);

datentraegergroesse:=0;
belegter_speicher:=0;
anzahl_eintraege:=0;
anzahl_ordner:=0;
beginn_der_toc:=0;
ende_der_toc:=0;

datentraegergroesse:=buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
datentraegergroesse:=datentraegergroesse+256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
datentraegergroesse:=datentraegergroesse+256*256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
datentraegergroesse:=datentraegergroesse+256*256*256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
memo1.lines.add('Datentraegergroesse: '+inttostr(datentraegergroesse)+' Bytes');

belegter_speicher:=buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
belegter_speicher:=belegter_speicher+256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
belegter_speicher:=belegter_speicher+256*256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
belegter_speicher:=belegter_speicher+256*256*256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
memo1.lines.add('Belegter Speicher: '+inttostr(belegter_speicher)+' Bytes');

anzahl_eintraege:=buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
anzahl_eintraege:=anzahl_eintraege+256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
anzahl_eintraege:=anzahl_eintraege+256*256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
anzahl_eintraege:=anzahl_eintraege+256*256*256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
memo1.lines.add('Anzahl der Eintraege: '+inttostr(anzahl_eintraege)+' Eintraege');

anzahl_ordner:=buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
anzahl_ordner:=anzahl_ordner+256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
anzahl_ordner:=anzahl_ordner+256*256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
anzahl_ordner:=anzahl_ordner+256*256*256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
memo1.lines.add('Anzahl der Ordner: '+inttostr(anzahl_ordner)+' Ordner');

beginn_der_toc:=buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
beginn_der_toc:=beginn_der_toc+256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
beginn_der_toc:=beginn_der_toc+256*256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
beginn_der_toc:=beginn_der_toc+256*256*256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
memo1.lines.add('Beginn der TOC: '+inttostr(beginn_der_toc)+' Segment');

ende_der_toc:=buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
ende_der_toc:=ende_der_toc+256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
ende_der_toc:=ende_der_toc+256*256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
ende_der_toc:=ende_der_toc+256*256*256*buf[aktuelle_speicherzelle];
aktuelle_speicherzelle:=aktuelle_speicherzelle+1;
memo1.lines.add('Ende der TOC: '+inttostr(ende_der_toc)+' Segment');
if checkbox2.Checked=true then begin
Mtoc_gelesen:=true;
button2.Visible:=false;
end;
end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
zwischenspeicher_int,toc_nummer,sektornummer,positionszahler_speicher:integer;
zwischenspeicher_single:real;
buf:array[0..511] of byte;
bytes: array[0..3] of Byte;
begin

form1.Button2.click;
toc_nummer:=strtoint(edit4.text);
zwischenspeicher_int:= trunc(toc_nummer/8);
sektornummer:=zwischenspeicher_int+3;

zwischenspeicher_single:=toc_nummer/8;
zwischenspeicher_single:=zwischenspeicher_single-zwischenspeicher_int;
zwischenspeicher_int:=round(zwischenspeicher_single*8);
positionszahler_speicher:=zwischenspeicher_int;

If Positionszahler_speicher = 0 Then begin
Positionszahler_speicher := 8;
Sektornummer := Sektornummer - 1;
End;

Positionszahler_speicher := Positionszahler_speicher * 64;
Positionszahler_speicher := Positionszahler_speicher - 64;

If Positionszahler_speicher = 0 Then begin
Positionszahler_speicher := 1;
end;

if image_geladen=false then begin
ReadSector(Sektornummer,@buf,form1.DriveComboBox1.Text);
end
else begin
imagezaehler:=(Sektornummer-1)*512+1;
bufferzaehler:=0;
while bufferzaehler<512 do begin
buf[bufferzaehler]:=byte(rominhalt[imagezaehler+bufferzaehler]);
bufferzaehler:=bufferzaehler+1;
end;
end;

ordnername:='';
zahler:=0;
Positionszahler_speicher:=Positionszahler_speicher-1;
while zahler<16 do begin
if buf[Positionszahler_speicher]>0 then begin
ordnername:=ordnername+chr(buf[Positionszahler_speicher]);
end;
Positionszahler_speicher:=Positionszahler_speicher+1;
zahler:=zahler+1;
end;
memo1.lines.add('Ordnername: '+ordnername);

dateiname:='';
zahler:=0;
while zahler<16 do begin
if buf[Positionszahler_speicher]>0 then begin
dateiname:=dateiname+chr(buf[Positionszahler_speicher]);
end;
Positionszahler_speicher:=Positionszahler_speicher+1;
zahler:=zahler+1;
end;
memo1.lines.add('Dateiname: '+dateiname);

datum_tag:=buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
datum_monat:=buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
datum_jahr:=buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
memo1.lines.add('Datum: '+inttostr(datum_tag)+'/'+inttostr(datum_monat)+'/'+inttostr(datum_jahr));

uhr_stunde:=buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
uhr_minute:=buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
uhr_sekunde:=buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
memo1.lines.add('Zeit: '+inttostr(uhr_stunde)+':'+inttostr(uhr_minute)+':'+inttostr(uhr_sekunde));

if checkbox4.Checked=true then begin
uhr_stunde:=uhr_stunde+1;
if checkbox5.Checked=true then begin
uhr_stunde:=uhr_stunde+1;
end;
if uhr_stunde>23 then begin
uhr_stunde:=0;
end;
end;
                                                       
bytes[0] := buf[Positionszahler_speicher];
bytes[1] := buf[Positionszahler_speicher+1];
bytes[2] := buf[Positionszahler_speicher+2];
bytes[3] := buf[Positionszahler_speicher+3];
position_nord:=Single(bytes);
Positionszahler_speicher:=Positionszahler_speicher+4;
memo1.lines.add('Position Nord '+floattostr(position_nord)+'');

bytes[0] := buf[Positionszahler_speicher];
bytes[1] := buf[Positionszahler_speicher+1];
bytes[2] := buf[Positionszahler_speicher+2];
bytes[3] := buf[Positionszahler_speicher+3];
position_ost:=Single(bytes);
Positionszahler_speicher:=Positionszahler_speicher+4;
memo1.lines.add('Position Ost: '+floattostr(position_ost)+'');

bytes[0] := buf[Positionszahler_speicher];
bytes[1] := buf[Positionszahler_speicher+1];
bytes[2] := buf[Positionszahler_speicher+2];
bytes[3] := buf[Positionszahler_speicher+3];
position_hoehe:=Single(bytes);
Positionszahler_speicher:=Positionszahler_speicher+4;
memo1.lines.add('Hoehe: '+floattostr(position_hoehe)+' m');

Dateianfang_sektor:=0;
Dateianfang_sektor:=buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
Dateianfang_sektor:=Dateianfang_sektor+256*buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
Dateianfang_sektor:=Dateianfang_sektor+256*256*buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
Dateianfang_sektor:=Dateianfang_sektor+256*256*256*buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
memo1.lines.add('Dateianfang '+inttostr(Dateianfang_sektor)+' Sektor');

Dateiende_sektor:=0;
Dateiende_sektor:=buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
Dateiende_sektor:=Dateiende_sektor+256*buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
Dateiende_sektor:=Dateiende_sektor+256*256*buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
Dateiende_sektor:=Dateiende_sektor+256*256*256*buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
memo1.lines.add('Dateiende '+inttostr(Dateiende_sektor)+' Sektor');

Dateiende_segment:=0;
Dateiende_segment:=buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
Dateiende_segment:=Dateiende_segment+256*buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
Dateiende_segment:=Dateiende_segment+256*256*buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
Dateiende_segment:=Dateiende_segment+256*256*256*buf[Positionszahler_speicher];
Positionszahler_speicher:=Positionszahler_speicher+1;
memo1.lines.add('Dateiende Segment '+inttostr(Dateiende_segment)+' Byte');

form1.Edit1.Text:=inttostr(Dateianfang_sektor+1);
form1.Edit2.Text:=inttostr(Dateiende_sektor+1);
form1.Edit5.Text:=inttostr(Dateiende_segment-2);

end;

procedure TForm1.Button4Click(Sender: TObject);
var toc_eintraganzaehler:integer;
buf:array[0..511] of byte;
anfangssektor, endsektor,aktiversektor, zahler,segmentende,endelement,zeit_anfang,zeit_anfang_sektor: integer;
hexstring,dateiname2: string;

datenrate,datenrate_sektor:real;
begin
Mtoc_gelesen:=false;
form1.Button2.Click;
if checkbox1.Checked=true then begin
form1.Edit4.text:='1';
toc_eintraganzaehler:=1;
endelement:=anzahl_eintraege;
end

else begin
if strtoint(edit6.text)<=anzahl_eintraege then begin
form1.Edit4.text:=edit6.Text;
toc_eintraganzaehler:=strtoint(edit6.Text);
end
else begin
form1.Edit4.text:=inttostr(anzahl_eintraege);
toc_eintraganzaehler:=anzahl_eintraege;
end;

if strtoint(edit7.text)<=anzahl_eintraege then begin
endelement:=strtoint(edit7.text);
end
else begin
endelement:=anzahl_eintraege;
end;
end;

memo1.Text:='';
progressbar1.min:=0;
progressbar1.Max:=endelement-toc_eintraganzaehler;
progressbar1.position:=0;
while toc_eintraganzaehler<=endelement do begin
zeit_anfang:=gettickcount();
form1.button3.click;
if ordnername='BILDER' then begin
   anfangssektor:=strtoint(form1.edit1.text);
  endsektor:=strtoint(form1.edit2.text);
  segmentende:=strtoint(form1.edit5.text);
  aktiversektor:=anfangssektor;
  if checkbox3.Checked=true then begin
  dateiname2:='Scroll.jpg';
  end
  else begin
  dateiname2:=Dateiname+'_'+inttostr(uhr_stunde)+'_'+inttostr(uhr_minute)+'_'+inttostr(uhr_sekunde)+'_'+form1.edit3.text+inttostr(gettickcount)+'.jpg';
  end;
  fs:=TFilestream.create(dateiname2,fmCreate or fmOpenReadWrite);
  hexstring:='';
  while aktiversektor<=endsektor do begin
  zeit_anfang_sektor:=gettickcount();



if image_geladen=false then begin
ReadSector(aktiversektor,@buf,form1.DriveComboBox1.Text);
end
else begin
imagezaehler:=(aktiversektor-1)*512+1;
bufferzaehler:=0;
while bufferzaehler<512 do begin
buf[bufferzaehler]:=byte(rominhalt[imagezaehler+bufferzaehler]);
bufferzaehler:=bufferzaehler+1;
end;
end;

  try
  if image_geladen=false then begin
  datenrate_sektor:= (((1)*512+dateiende_segment)/1024)/((gettickcount()-zeit_anfang_sektor)/1000);
  end;
   except
   end;
   zahler:=0;
  if aktiversektor<>endsektor then begin
  while zahler<=511 do begin

  fs.Write(buf[zahler],1);
  zahler:=zahler+1;
  end;
  end
  else begin
  while zahler<=segmentende do begin

  fs.Write(buf[zahler],1);
  zahler:=zahler+1;
  end;
  end;
  aktiversektor:=aktiversektor+1;
  end;

  fs.free;

if checkbox3.Checked=TRUE then begin
if checkbox6.Checked=true then begin

   jpeg2:=TJPEGImage.Create;
   try
   jpeg2.LoadFromFile('Scroll.jpg');
   bmp:=TBitmap.Create;
   try
   bmp.Assign(jpeg2);
   turn180(bmp);
   if checkbox7.Checked=true then begin
   bmp_2:=TBitmap.Create;
   bmp_2.assign(bmp);
   xzahler:=0;
   yzahler:=0;
   while yzahler<bmp.height do begin
   while xzahler<bmp.width do begin
   bmp_2.Canvas.Pixels[xzahler,yzahler]:=bmp.Canvas.Pixels[bmp.width-xzahler,yzahler];
   xzahler:=xzahler+1;
   end;
   xzahler:=0;
   yzahler:=yzahler+1;               
   end;
   bmp.assign(bmp_2);
   end;

   jpeg2.assign(bmp);
   jpeg2.SaveToFile('Scroll.jpg');
   finally
   bmp.free;
   end;
   finally
   jpeg2.free;
   end;
end;
try
image1.Picture.LoadFromFile('Scroll.jpg');
except
form1.StatusBar1.SimpleText:='Fehler beim Laden des Bildes';
end;
end;                                                                                           
  progressbar1.position:=progressbar1.Position+1;
  try
  datenrate:= (((dateiende_sektor-dateianfang_sektor)*512+dateiende_segment)/1024)/((gettickcount()-zeit_anfang)/1000);
  except
  end;
  form1.StatusBar1.SimpleText:='Transferrate (effektiv): '+floattostr(trunc(datenrate))+' kByte/s'+'   Transferrate (Karte): '+floattostr(trunc(datenrate_sektor))+' kByte/s';
  end;
toc_eintraganzaehler:=toc_eintraganzaehler+1;
form1.Edit4.text:=inttostr(toc_eintraganzaehler);
end;
progressbar1.position:=0;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  memo1.Text:='';
end;

procedure TForm1.Button6Click(Sender: TObject);
var toc_eintraganzaehler:integer;
buf:array[0..511] of byte;
anfangssektor, endsektor,aktiversektor, zahler,segmentende,endelement: integer;
begin
Mtoc_gelesen:=false;
statusbar1.SimpleText:='TOC Eintrge werden gelesen.';
form1.Button2.Click;
if checkbox1.Checked=true then begin
form1.Edit4.text:='1';
toc_eintraganzaehler:=1;
endelement:=anzahl_eintraege;
end

else begin
if strtoint(edit6.text)<=anzahl_eintraege then begin
form1.Edit4.text:=edit6.Text;
toc_eintraganzaehler:=strtoint(edit6.Text);
end
else begin
form1.Edit4.text:=inttostr(anzahl_eintraege);
toc_eintraganzaehler:=anzahl_eintraege;
end;

if strtoint(edit7.text)<=anzahl_eintraege then begin
endelement:=strtoint(edit7.text);
end
else begin
endelement:=anzahl_eintraege;
end;
end;
memo1.Text:='';
while toc_eintraganzaehler<=endelement do begin
memo1.lines.add('TOC-Eintrag: '+inttostr(toc_eintraganzaehler));
form1.button3.click;
toc_eintraganzaehler:=toc_eintraganzaehler+1;
form1.Edit4.text:=inttostr(toc_eintraganzaehler);
memo1.lines.add('');
memo1.lines.add('');

end;
memo1.lines.savetofile('TOC_'+inttostr(gettickcount)+'.txt');
statusbar1.SimpleText:='TOC Eintrge wurden gespeichert.';
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
if checkbox2.Checked=true then begin
Mtoc_gelesen:=true;
button2.Visible:=false;
end
else begin
Mtoc_gelesen:=false;
button2.Visible:=true;
end;
end;

procedure TForm1.Button7Click(Sender: TObject);
var toc_eintraganzaehler:integer;
buf:array[0..511] of byte;
anfangssektor, endsektor,aktiversektor, zahler,segmentende,endelement,zeit_anfang: integer;
hexstring,dateiname2: string;
fs:TFilestream;
datenrate:real;
begin
Mtoc_gelesen:=false;
checkbox1.Checked:=true;
form1.Button2.Click;
statusbar1.SimpleText:='GPS Datensatz wird erstellt.';
if checkbox1.Checked=true then begin
form1.Edit4.text:='1';
toc_eintraganzaehler:=1;
endelement:=anzahl_eintraege;
end

else begin
if strtoint(edit6.text)<=anzahl_eintraege then begin
form1.Edit4.text:=edit6.Text;
toc_eintraganzaehler:=strtoint(edit6.Text);
end
else begin
form1.Edit4.text:=inttostr(anzahl_eintraege);
toc_eintraganzaehler:=anzahl_eintraege;
end;

if strtoint(edit7.text)<=anzahl_eintraege then begin
endelement:=strtoint(edit7.text);
end
else begin
endelement:=anzahl_eintraege;
end;
end;

memo1.Text:='';
memo2.Text:='';
progressbar1.min:=0;
progressbar1.Max:=endelement-toc_eintraganzaehler;
progressbar1.position:=0;

memo3.Text:='';
memo3.Lines.add('<gpx>');
memo3.Lines.add('<trk>');
memo3.Lines.add('<name>BILD-Logger</name>');
memo3.Lines.add('<trkseg>');


pos_zaehler_b:=0;
pos_x_r_max:=0;
pos_x_r_min:=360;
pos_y_r_max:=0;
pos_y_r_min:=360;

while toc_eintraganzaehler<=endelement do begin
form1.button3.click;
if ordnername<>'INIT' then begin

if position_ost>0 then begin

pos_x_r[pos_zaehler_b]:=position_ost;
pos_y_r[pos_zaehler_b]:=position_nord;
pos_ges_bildnr[pos_zaehler_b]:=toc_eintraganzaehler;
if pos_x_r_max<pos_x_r[pos_zaehler_b] then begin
pos_x_r_max:=pos_x_r[pos_zaehler_b];
end;

if pos_y_r_max<pos_y_r[pos_zaehler_b] then begin
pos_y_r_max:=pos_y_r[pos_zaehler_b];
end;

if pos_x_r_min>pos_x_r[pos_zaehler_b] then begin
pos_x_r_min:=pos_x_r[pos_zaehler_b];
end;

if pos_y_r_min>pos_y_r[pos_zaehler_b] then begin
pos_y_r_min:=pos_y_r[pos_zaehler_b];
end;

pos_zaehler_b:=pos_zaehler_b+1;

memo3.Lines.add('<trkpt lat="'+StringReplace(floattostr(position_nord),',','.',[rfReplaceAll, rfIgnoreCase])+'" lon="'+StringReplace(floattostr(position_ost),',','.',[rfReplaceAll, rfIgnoreCase])+'">');
memo3.lines.add('<ele>'+inttostr(trunc(position_hoehe))+'</ele>');
memo3.lines.add('</trkpt>');
if (uhr_Stunde>9) and(uhr_minute>9) then begin
memo2.Lines.add(inttostr(uhr_stunde)+inttostr(uhr_minute)+'   '+StringReplace(floattostr(position_nord),',','.',[rfReplaceAll, rfIgnoreCase])+'   '+StringReplace(floattostr(position_ost),',','.',[rfReplaceAll, rfIgnoreCase])+'   '+inttostr(trunc(position_hoehe)));
end;

if (uhr_Stunde<=9) and(uhr_minute>9) then begin
memo2.Lines.add('0'+inttostr(uhr_stunde)+inttostr(uhr_minute)+'   '+StringReplace(floattostr(position_nord),',','.',[rfReplaceAll, rfIgnoreCase])+'   '+StringReplace(floattostr(position_ost),',','.',[rfReplaceAll, rfIgnoreCase])+'   '+inttostr(trunc(position_hoehe)));
end;


if (uhr_Stunde>9) and(uhr_minute<=9) then begin
memo2.Lines.add(inttostr(uhr_stunde)+'0'+inttostr(uhr_minute)+'   '+StringReplace(floattostr(position_nord),',','.',[rfReplaceAll, rfIgnoreCase])+'   '+StringReplace(floattostr(position_ost),',','.',[rfReplaceAll, rfIgnoreCase])+'   '+inttostr(trunc(position_hoehe)));
end;

if (uhr_Stunde<=9) and(uhr_minute<=9) then begin
memo2.Lines.add('0'+inttostr(uhr_stunde)+'0'+inttostr(uhr_minute)+'   '+StringReplace(floattostr(position_nord),',','.',[rfReplaceAll, rfIgnoreCase])+'   '+StringReplace(floattostr(position_ost),',','.',[rfReplaceAll, rfIgnoreCase])+'   '+inttostr(trunc(position_hoehe)));
end;
end;
end;
toc_eintraganzaehler:=toc_eintraganzaehler+1;
form1.Edit4.text:=inttostr(toc_eintraganzaehler);
progressbar1.position:=progressbar1.position+1;
end;

memo2.lines.savetofile('GPS_'+edit3.text+inttostr(gettickcount)+'.txt');
memo3.Lines.add('</trkseg>') ;
memo3.Lines.add('</trk>');
memo3.Lines.add('</gpx>');
memo3.lines.savetofile('GPS_'+edit3.text+inttostr(gettickcount)+'.gpx');

if pos_x_r_max-pos_x_r_min>0 then begin
scale_factor_x:=image2.width/(pos_x_r_max-pos_x_r_min);
end
else begin
statusbar1.SimpleText:='Grafik kann nicht erstellt werden';
scale_factor_x:=0;
end;
if pos_y_r_max-pos_y_r_min>0 then begin
scale_factor_y:=image2.height/(pos_y_r_max-pos_y_r_min);
end
else begin
statusbar1.SimpleText:='Grafik kann nicht erstellt werden';
scale_factor_y:=0;
end;
zahler:=0;
image2.Canvas.Rectangle(0,0,image2.width,image2.height);
image2.Canvas.moveto(pos_x_b[zahler],image2.height-pos_y_b[zahler]);
while zahler<pos_zaehler_b do begin
pos_x_b[zahler]:= trunc(scale_factor_x*(pos_x_r[zahler]-pos_x_r_min));
pos_y_b[zahler]:= trunc(scale_factor_y*(pos_y_r[zahler]-pos_y_r_min));
image2.Canvas.LineTo(pos_x_b[zahler],image2.height-pos_y_b[zahler]);
zahler:=zahler+1;
end;

label16.Caption:=floattostr((trunc(pos_x_r_max*10000)/10000));
label15.Caption:=floattostr((trunc(pos_x_r_min*10000)/10000));
label18.Caption:=floattostr((trunc(pos_y_r_max*10000)/10000));
label17.Caption:=floattostr((trunc(pos_y_r_min*10000)/10000));
image2.Visible:=true;

progressbar1.position:=0;
end;

procedure TForm1.Button8Click(Sender: TObject);
var dateiname2:string;
begin
statusbar1.SimpleText:='Imageerstellung wird vorbereitet.';
button2.click;
if anzahl_eintraege>0 then begin
statusbar1.SimpleText:='Dateiname fr Image wird abgefragt.';
if savedialog1.Execute then begin
dateiname2:=savedialog1.FileName+'.img';
end;

if dateiname2<>'' then begin
statusbar1.SimpleText:='Imageerstellung wird gestartet.';
edit4.text:=inttostr(anzahl_eintraege);
button3.click;
edit1.text:='1';
edit2.text:= inttostr(dateiende_sektor);
anfangssektor:=strtoint(form1.edit1.text);
endsektor:=strtoint(form1.edit2.text);
segmentende:=strtoint(form1.edit5.text);                 
aktiversektor:=anfangssektor;
progressbar1.min:=0;
progressbar1.Max:=endsektor;
progressbar1.position:=0;
zeit_anfang:=gettickcount();
fs:=TFilestream.create(dateiname2,fmCreate or fmOpenReadWrite);
 while aktiversektor<=endsektor do begin
  zeit_anfang_sektor:=gettickcount();

   ReadSector(aktiversektor,@buf,form1.DriveComboBox1.Text);
   
  try
  datenrate_sektor:= (((1)*512+dateiende_segment)/1024)/((gettickcount()-zeit_anfang_sektor)/1000);
   except
   end;
   progressbar1.position:=progressbar1.Position+1;
   form1.StatusBar1.SimpleText:='Sektor: '+ inttostr(aktiversektor)+' von '+inttostr(endsektor)+'.   Transferrate (Karte): '+floattostr(trunc(datenrate_sektor))+' kByte/s';
   zahler:=0;
  if aktiversektor<>endsektor then begin
  while zahler<=511 do begin

  fs.Write(buf[zahler],1);
  zahler:=zahler+1;
  end;
  end
  else begin
  while zahler<=segmentende do begin

  fs.Write(buf[zahler],1);
  zahler:=zahler+1;
  end;
  end;
  aktiversektor:=aktiversektor+1;
  end;

  fs.free;
  statusbar1.SimpleText:='Imageerstellung wurde erfolgreich beendet.';
  
end
else begin
statusbar1.SimpleText:='Imageerstellung abgebrochen - Es wurde kein Dateiname gewhlt.';
end;
end
else begin
statusbar1.SimpleText:='Imageerstellung abgebrochen - Das Quellmedium enthlt keine Daten.';
end;


end;

procedure TForm1.Button9Click(Sender: TObject);
begin
if opendialog1.Execute then begin
imagedateiname:=opendialog1.FileName;
edit8.text:=imagedateiname;
if edit8.text<>'' then begin
image:=TFilestream.create(imagedateiname,fmOpenRead);
SetLength(rominhalt, image.Size);
image.ReadBuffer(rominhalt[1], image.Size);
image_geladen:=true;
button8.visible:=false;
button10.Visible:=true;
button9.visible:=false;
button2.visible:=true;
end;
end;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
image.free;
edit8.text:='';
button9.visible:=true;
button8.visible:=true;
button10.visible:=false;
image_geladen:=false; 
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
image_geladen:=false;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
if checkbox3.checked=true then begin
statusbar1.SimpleText:='Bildausgabe aktiviert.';
button2.click;
trackbar1.Max:=anzahl_eintraege;
trackbar1.min:=2;
button2.Visible:=false;
button3.Visible:=false;
button4.Visible:=false;
button6.Visible:=false;
button7.Visible:=false;

end
else begin
statusbar1.SimpleText:='Bildausgabe deaktiviert.';
button2.Visible:=true;
button3.Visible:=true;
button4.Visible:=true;
button6.Visible:=true;
button7.Visible:=true;

end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
if checkbox3.Checked=true then begin
edit6.text:=inttostr(trackbar1.position);
edit7.text:=inttostr(trackbar1.position);
button4.click;
if (uhr_Stunde>9) and(uhr_minute>9) then begin
label11.caption:=(inttostr(uhr_stunde)+':'+inttostr(uhr_minute)+':'+inttostr(uhr_sekunde));
end;

if (uhr_Stunde<=9) and(uhr_minute>9) then begin
label11.caption:=('0'+inttostr(uhr_stunde)+':'+inttostr(uhr_minute)+':'+inttostr(uhr_sekunde));
end;


if (uhr_Stunde>9) and(uhr_minute<=9) then begin
label11.caption:=(inttostr(uhr_stunde)+':'+'0'+inttostr(uhr_minute)+':'+inttostr(uhr_sekunde));
end;

if (uhr_Stunde<=9) and(uhr_minute<=9) then begin
label11.caption:=('0'+inttostr(uhr_stunde)+':'+'0'+inttostr(uhr_minute)+':'+inttostr(uhr_sekunde));
end;

label12.caption:=StringReplace(floattostr(position_nord),',','.',[rfReplaceAll, rfIgnoreCase])+'N,   '+StringReplace(floattostr(position_ost),',','.',[rfReplaceAll, rfIgnoreCase])+'E,   '+inttostr(trunc(position_hoehe))+'m';
end;
end;

procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
checkbox1.Checked:=false;
statusbar1.SimpleText:='Koordinatenauswahl.';
unterschied_min:=(sqrt(image2.Width*image2.Width+image2.height*image2.height));
zahler:=0;
while zahler<pos_zaehler_b do begin
unterschied:=(sqrt(abs(pos_x_b[zahler]-X)*abs(pos_x_b[zahler]-X)+abs(image2.height-pos_y_b[zahler]-Y)*abs(image2.height-pos_y_b[zahler]-Y)));
if unterschied<unterschied_min then begin
toc_unterschied_min:=pos_ges_bildnr[zahler];
unterschied_min:=unterschied;
label19.Caption:='GPS-Punkt: '+inttostr(zahler);
end;
zahler:=zahler+1;
end;
checkbox3.checked:=true;
trackbar1.Position:=toc_unterschied_min;
edit6.text:=inttostr(toc_unterschied_min);
edit7.text:=inttostr(toc_unterschied_min);

end;


procedure TForm1.CheckBox6Click(Sender: TObject);
begin
if checkbox6.Checked=true then begin
checkbox7.Visible:=true;
end
else begin
checkbox7.Visible:=false;
checkbox7.checked:=false;
end;
end;

procedure TForm1.Button11Click(Sender: TObject);
var laufwerkszaehler:integer;
begin
laufwerkszaehler:=0;
DriveComboBox1.Refresh;
while laufwerkszaehler<form1.DriveComboBox1.Items.Count do begin
form1.DriveComboBox1.ItemIndex:=laufwerkszaehler;
button2.Click;
Mtoc_gelesen:=false;
button2.Visible:=true;
if (datentraegergroesse>0) and (belegter_speicher>0) and (anzahl_eintraege>0) then begin
laufwerkszaehler:= form1.DriveComboBox1.Items.Count;
//showmessage('Laufwerk gefunden.');
end
else begin
memo1.Text:='';
end;
laufwerkszaehler:=laufwerkszaehler+1;
end;
end;

end.
